#include "cflironecontrol.h"

//- --------------------------------------------------------
CFlirOneControl::CFlirOneControl(void)
{
 USBDeviceHandle=NULL;
 SizeOfData=1048576;
 Data=new unsigned char[SizeOfData]; 
 
 ImageBuffer=new unsigned char[IMAGE_BUFFER_SIZE];
 ImageBufferSize=0;
 ImageIndex=0;

 for(long n=0;n<256;n++)
 {
  ColorMap_R[n]=(unsigned char)n;
  ColorMap_G[n]=(unsigned char)n;
  ColorMap_B[n]=(unsigned char)n;
 }
 Path=new char[255];
 sprintf(Path,""); 
}
//- ---------------------------------------------------------
CFlirOneControl::~CFlirOneControl()
{
 delete[](Data);
 delete[](ImageBuffer);
 delete[](Path);
 Close();
}
//- ------------------------------------------------------------

//----------------------------------------------------------------------------------------------------
//  
//----------------------------------------------------------------------------------------------------
void CFlirOneControl::SetPath(char *path)
{
 delete[](Path);
 Path=new char[strlen(path)+1];
 strcpy(Path,path);
}
//----------------------------------------------------------------------------------------------------
//  
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::Open(void)
{
 Close();
 
 if (libusb_init(NULL)<0)
 {     
  Close();
  AddLog("[]    LibUsb!\r\n");
  return(false);
 }
 // Flir One Gen 2
 USBDeviceHandle=libusb_open_device_with_vid_pid(NULL,VENDOR_ID,PRODUCT_ID); 
 if (USBDeviceHandle==NULL)
 {
  Close();
  AddLog("[]  Flir One Gen 2  !\r\n");
  return(false);
 }
 printf("Flir One gen 2 find!\r\n");
 //  
 if (libusb_set_configuration(USBDeviceHandle,3)<0)
 {
  Close();
  AddLog("[]    !\r\n");
  return(false);
 }
 if (libusb_claim_interface(USBDeviceHandle,0)<0)
 {
  Close();
  AddLog("[]    0!\r\n");
  return(false);
 } 
 if (libusb_claim_interface(USBDeviceHandle,1)<0)
 {
  Close();
  AddLog("[]    1!\r\n");
  return(false);
 }
 if (libusb_claim_interface(USBDeviceHandle,2)<0)
 {
  Close();
  AddLog("[]    2!\r\n");
  return(false);
 }
 AddLog("  .\r\n");
 Mode=1;
 return(true);
}
//----------------------------------------------------------------------------------------------------
//  
//----------------------------------------------------------------------------------------------------
void CFlirOneControl::Close(void)
{
 if (USBDeviceHandle!=NULL)
 {
  AddLog(" .\r\n");
  libusb_reset_device(USBDeviceHandle);
  libusb_close(USBDeviceHandle);
  libusb_exit(NULL);
 }
 USBDeviceHandle=NULL;
}
//----------------------------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::Processing(void)
{
 if (USBDeviceHandle==NULL) return(false);
 unsigned char data[2]={0,0};
 unsigned long mode=Mode;
 int size;
 if (mode==1)
 {  
  data[0]=0;
  data[1]=0;
  //  2 (FRAME)
  if (libusb_control_transfer(USBDeviceHandle,1,0x0b,0,2,data,0,100)<0)
  {
   Close();
   AddLog("[]    2!\r\n");
   return(false);// 
  }
  data[0]=0;
  data[1]=0;
  //  1 (FILEIO)
  if (libusb_control_transfer(USBDeviceHandle,1,0x0b,0,1,data,0,100)<0) 
  {
   Close();
   AddLog("[]    1!\r\n");
   return(false);// 
  }  
  data[0]=0;
  data[1]=0;
  //  1 (FILEIO)
  if (libusb_control_transfer(USBDeviceHandle,1,0x0b,1,1,data,0,100)<0)
  {
   Close();
   AddLog("[]    1!\r\n");
   return(false);// 
  }
  Mode=3;
 } 
 if (mode==2)
 {
/*

  unsigned char my_string2[16]={0xcc,0x01,0x00,0x00,0x01,0x00,0x00,0x00,0x41,0x00,0x00,0x00,0xF8,0xB3,0xF7,0x00};
  char my_string[128];
  long length=16;
  long transferred=usb_bulk_write(USBDeviceHandle,2,reinterpret_cast<char*>(my_string2),length,0);
  if (transferred!=length) 
  {
   Close();
   AddLog("[]     1!\r\n");
   return(false);
  }
  strcpy(my_string,"{\"type\":\"openFile\",\"data\":{\"mode\":\"r\",\"path\":\"CameraFiles.zip\"}}");
  length=strlen(my_string)+1;
  transferred=usb_bulk_write(USBDeviceHandle,USB_ENDPOINT_OUT|USB_RECIP_ENDPOINT,reinterpret_cast<char*>(my_string),length,0);
  if (transferred!=length) 
  {
   Close();
   AddLog("[]     2!\r\n");
   return(false);
  }
  unsigned char my_string3[16]={0xcc,0x01,0x00,0x00,0x01,0x00,0x00,0x00,0x33,0x00,0x00,0x00,0xef,0xdb,0xc1,0xc1};
  length=16;
  transferred=usb_bulk_write(USBDeviceHandle,USB_ENDPOINT_OUT|USB_RECIP_ENDPOINT,reinterpret_cast<char*>(my_string3),length,0);
  if (transferred!=length) 
  {
   Close();
   AddLog("[]     3!\r\n");
   return(false);
  }
  strcpy(my_string,"{\"type\":\"readFile\",\"data\":{\"streamIdentifier\":10}}");
  length=strlen(my_string)+1;
  transferred=usb_bulk_write(USBDeviceHandle,USB_ENDPOINT_OUT|USB_RECIP_ENDPOINT,reinterpret_cast<char*>(my_string),length,0);
  if (transferred!=length) 
  {
   Close();
   AddLog("[]     4!\r\n");
   return(false);
  }*/
  Mode=3;
 }
 if (mode==3)
 {
  //  2 (FRAME)
  data[0]=0;
  data[1]=0;
  if (libusb_control_transfer(USBDeviceHandle,1,0x0b,1,2,data,0,200)<0)
  {
   Close();
   AddLog("[]     frame!\r\n");
   return(false);// 
  }
 printf("Flir One gen 2 get data...!\r\n");
  Mode=4;
 }
 if (mode==4)
 {
  long ret=libusb_bulk_transfer(USBDeviceHandle,0x85,Data,SizeOfData,&size,100);
  if (ret>=0)
  {
   if (size>0)
   {
    CreateImage((unsigned char*)Data,size);     
    /*
    printf("Data!\r\n");
    AddLog("  frame.\r\n");
    FILE *file=fopen("data.txt","ab");
    fwrite(Data,size,1,file);
    fclose(file);
    */
   }
  }
  else
  {
   printf("Error! %s\r\n",libusb_error_name(ret));
   AddLog("[]    frame! ");
   //AddLog(usb_strerror());
  }
 }
 long ret=libusb_bulk_transfer(USBDeviceHandle,0x81,Data,SizeOfData,&size,10);
 /*
 if (received<0)
 {
  AddLog("[]    iAP! ");
  AddLog(usb_strerror());
 }
 else AddLog("  iAP.\r\n");
 */
 ret=libusb_bulk_transfer(USBDeviceHandle,0x83,Data,SizeOfData,&size,10);
 /*
 if (received<0)
 {
  AddLog("[]    fileio! ");
  AddLog(usb_strerror());
 }
 else AddLog("  fileio.\r\n");
 */
 
 if (strcmp(libusb_error_name(ret),"LIBUSB_ERROR_NO_DEVICE")==0)
 {
  Close();
  AddLog("[]  LIBUSB_ERROR_NO_DEVICE!\r\n");
  return(false);
 }
 return(true);
}


//----------------------------------------------------------------------------------------------------
//   log-
//----------------------------------------------------------------------------------------------------
void CFlirOneControl::AddLog(char *string)
{
 return;  
 FILE *file=fopen("log.txt","ab");
 if (file==NULL) return;
 fprintf(file,"%s",string);
 fclose(file);
}

//----------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::CreateImage(unsigned char *buffer,unsigned long size)
{
 unsigned long n;
 long x;
 long y;
 if (size+ImageBufferSize>=IMAGE_BUFFER_SIZE) ImageBufferSize=0;//  
 // 
 for(n=0;n<size;n++) ImageBuffer[n+ImageBufferSize]=buffer[n];
 ImageBufferSize+=size; 
 if (ImageBufferSize<4) return(false);

 //     4  ,     
 unsigned char magicbyte[4]={0xEF,0xBE,0x00,0x00};
 for(n=0;n<ImageBufferSize-4;n++)
 {
  long m;
  bool ok=true;
  for(m=0;m<4;m++)
  {
   if (ImageBuffer[n+m]==magicbyte[m]) continue;
   ok=false;
   break;
  }
  if (ok==true)// 
  {
   //   
   long size=ImageBufferSize-n-4;
   for(m=0;m<size;m++) ImageBuffer[m]=ImageBuffer[m+n+4];
   ImageBufferSize=size;
   n=0;//  
  }
 }
 if (ImageBufferSize<24) return(false);//  
 unsigned long FrameSize=*((unsigned long *)(ImageBuffer+8));
 unsigned long ThermalSize=*((unsigned long *)(ImageBuffer+12));
 unsigned long JpgSize=*((unsigned long *)(ImageBuffer+16));
 unsigned long StatusSize=*((unsigned long *)(ImageBuffer+20));
 if (FrameSize+28>ImageBufferSize) return(false);//    

 // 
 ImageBufferSize=0;
 unsigned short *raw_thermal_image=new unsigned short[160*120];
 unsigned char *rgb_thermal_image=new unsigned char[160*120*4];
 for(n=0;n<160*120;n++)
 {
  raw_thermal_image[n]=128;
  rgb_thermal_image[n*4+0]=128;
  rgb_thermal_image[n*4+1]=128;
  rgb_thermal_image[n*4+2]=128;
  rgb_thermal_image[n*4+3]=0xff;
 }
 //   (164   )
 long min=0x10000;
 long max=0;
 for(y=0;y<120;y++) 
 {
  for(x=0;x<160;x++)
  {   
   long offset=(y*164+x)*2+28;
   if (x>=80) offset+=4;
   unsigned short value=*((unsigned short*)(ImageBuffer+offset));
   raw_thermal_image[x+y*160]=value;
   if (value<min) min=value;
   if (value>max) max=value;
  }
 }
 // 
 long delta=max-min;
 if (delta==0) delta=1;
 for(x=0;x<160;x++)
 {
  for(y=0;y<120;y++)
  {
   long offset=x+y*160;
   long value=raw_thermal_image[offset];
   value-=min;
   value=(value*255)/delta;
   offset=y+(159-x)*120;
   value&=0xff;
   rgb_thermal_image[offset*4+0]=ColorMap_B[value];
   rgb_thermal_image[offset*4+1]=ColorMap_G[value];
   rgb_thermal_image[offset*4+2]=ColorMap_R[value];
   rgb_thermal_image[offset*4+3]=0xff;
  }
 }
 // 
 char *filename=new char[strlen(Path)+255];
 sprintf(filename,"%s/image/img%04i.tga",Path,ImageIndex);
 printf("%s\r\n",filename);
 SaveTGA(filename,120,160,rgb_thermal_image);
 delete[](rgb_thermal_image);
 delete[](raw_thermal_image);
 ImageIndex++;
 return(true);
}
//----------------------------------------------------------------------------------------------------
//   
//----------------------------------------------------------------------------------------------------
bool CFlirOneControl::LoadColorMap(char *filename)
{ 
 FILE *file=fopen(filename,"rb");
 if (file==NULL) return(false);
 unsigned char colormap[768];
 if (fread(colormap,sizeof(unsigned char),768,file)<768)
 {
  fclose(file);
  return(false);
 }
 fclose(file);
 for(long n=0;n<256;n++)
 {
  ColorMap_R[n]=colormap[n*3+0];
  ColorMap_G[n]=colormap[n*3+1];
  ColorMap_B[n]=colormap[n*3+2];
 }
 return(true);
}

//---------------------------------------------------------------------

