#ifndef CFLIRONECONTROL_H
#define CFLIRONECONTROL_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libusb.h"
#include "tga.h"

#define VENDOR_ID	0x09cb
#define PRODUCT_ID	0x1996

#define IMAGE_BUFFER_SIZE 1048576

//  Flir One
class CFlirOneControl
{
 protected:
  //- -------------------------------------------------------  
  libusb_device_handle *USBDeviceHandle;// 
  long Mode;
  unsigned char *Data;
  unsigned long SizeOfData;
  
  unsigned char *ImageBuffer;//     
  unsigned long ImageBufferSize;//     
  long ImageIndex;//  

  unsigned char ColorMap_R[256];//  
  unsigned char ColorMap_G[256];//  
  unsigned char ColorMap_B[256];//  
  
  char *Path;// 
  //- ----------------------------------------------------------
  //-------------------------------------------------------------------
 public:
  //- ------------------------------------------------------
  CFlirOneControl(void);
  //- -------------------------------------------------------
  ~CFlirOneControl();
  //- -------------------------------------------------------
  //- ----------------------------------------------------------
  void SetPath(char *path);//  
  bool Open(void);//  
  void Close(void);//  
  bool Processing(void);//
  bool CreateImage(unsigned char *buffer,unsigned long size);// 
  bool LoadColorMap(char *filename);//   
  //-------------------------------------------------------------------
 protected:
  void AddLog(char *string);//   log-
};

#endif
